#include <stdio.h>
#include <stdlib.h>


void Set(unsigned char *v, int bit)
{
	*v |= (1 << bit);
}


int Bit(int bit, unsigned int n)
{
	return n & (1 << bit);
}


void DoBytes(unsigned int f, unsigned char *v1, unsigned char *v2)
{
	unsigned int a, n;

	n = f / 40;
	a = f % 40;

	if (Bit(0, n))
		Set(v2, 7);
	if (Bit(1, n))
		Set(v2, 6);
	if (Bit(2, n))
		Set(v2, 5);
	if (Bit(3, n))
		Set(v2, 4);
	if (Bit(4, n))
		Set(v2, 3);
	if (Bit(5, n))
		Set(v2, 0);
	if (Bit(6, n))
		Set(v2, 1);
	if (Bit(7, n))
		Set(v2, 2);
	if (Bit(8, n))
		Set(v1, 0);
	if (Bit(9, n))
		Set(v1, 1);

	if (Bit(0, a))
		Set(v1, 2);
	if (Bit(1, a))
		Set(v1, 7);
	if (Bit(2, a))
		Set(v1, 6);
	if (Bit(3, a))
		Set(v1, 5);
	if (Bit(4, a))
		Set(v1, 4);
	if (Bit(5, a))
		Set(v1, 3);
}


void main(void)
{
	char buff[80];
	unsigned int f;
	unsigned char v1, v2;

	for (;;)
	{
		printf ("Frequency (kHz): ");
		gets(buff);
		f = atoi(buff) / 5;
		if (!f)
			break;

		v1 = v2 = 0;
		DoBytes(f, &v1, &v2);
		printf ("TX: %02X %02X\n", v1, v2);

		f += 10700/5;
		v1 = v2 = 0;
		DoBytes(f, &v1, &v2);
		printf ("RX: %02X %02X\n", v1, v2);
	}
}
